require "import"
import "com.androlua.Ticker"
import "android.media.MediaPlayer"
import "android.os.*"
import "android.content.*"
import "android.widget.*"

files = {
    "/storage/emulated/0/解说/Plugins/Alarme da bateria/battery alarm.mp3",
    "/storage/emulated/0/解说/Plugins/Alarme da bateria/alarm 2.ogg",
    "/storage/emulated/0/解说/Plugins/Alarme da bateria/Batteries Getting Lo.mp3",
}

local play_count_77 = 0
local last_announced_battery_level = -1
local music_playing = false
local announcement_pending = false

function play_music(index, volume, callback)
    local file = files[index]
    local mp = MediaPlayer()
    local success, err = pcall(function()
        mp.setDataSource(file)
    end)

    if not success then
        print("Error setting data source: " .. err)
        service.speak("Erro: arquivo de áudio não encontrado.")
        return
    end

    mp.setVolume(volume, volume)
    mp.prepare()

    mp.setOnCompletionListener(MediaPlayer.OnCompletionListener {
        onCompletion = function()
            mp.release()
            music_playing = false
            if callback then callback() end
        end
    })

    mp.start()
    music_playing = true
end

function play_second_music_5_times(level)
    if not music_playing then
        play_count_77 = 0
        local function play_next()
            if play_count_77 < 5 then
                play_count_77 = play_count_77 + 1
                play_music(2, 9.9, play_next)
            else
                last_announced_battery_level = level
                announcement_pending = true
            end
        end
        play_next()
    end
end

function announce_battery_level(level)
    local s = "O nível atual da bateria é " .. tostring(level) .. " percent"
    service.speak(s)
end

function delayed_announcement(level)
    local handler = Handler(Looper.getMainLooper())
    handler.postDelayed(function()
        announce_battery_level(level)
    end, 1000)
end

if ti then
    ti.stop()
    service.speak("Alarme da bateria desativado")
    ti = nil
    return true
end

local lastBatteryLevel = service.getBatteryLevel()

ti = Ticker()
ti.Period = 1000
ti.onTick = function()
    local currentBatteryLevel = service.getBatteryLevel()
    local intentFilter = IntentFilter(Intent.ACTION_BATTERY_CHANGED)
    local intent = this.registerReceiver(nil, intentFilter)
    local status = intent.getIntExtra(BatteryManager.EXTRA_STATUS, -1)

    if currentBatteryLevel ~= lastBatteryLevel then
        if currentBatteryLevel % 10 == 0 and currentBatteryLevel ~= last_announced_battery_level then
            if currentBatteryLevel == 95 then
                if play_count_77 == 0 and last_announced_battery_level ~= 77 then
                    play_second_music_5_times(currentBatteryLevel)
                end
            else
                if not music_playing then
                    play_music(1, 9.9, function()
                        delayed_announcement(currentBatteryLevel)
                    end)
                    last_announced_battery_level = currentBatteryLevel
                else
                    announcement_pending = true
                end
            end
        elseif currentBatteryLevel == 20 and currentBatteryLevel ~= last_announced_battery_level then
            if not music_playing then
                play_music(3, 9.9, function()
                    delayed_announcement(currentBatteryLevel)
                end)
                last_announced_battery_level = currentBatteryLevel
            else
                announcement_pending = true
            end
        end
    end

    if announcement_pending and not music_playing then
        delayed_announcement(currentBatteryLevel)
        announcement_pending = false
    end

    lastBatteryLevel = currentBatteryLevel
end

ti.start()
service.speak("Alarme da bateria ativado")